package edu.lawrence.hotel;

import java.time.LocalDate;

public class Reservation implements Comparable<Reservation> {
    private int idNumber;
    private int customerNumber;
    private LocalDate day;
    private int startHour;
    private int endHour;
    private int groupSize;
    private String room;
    
    public Reservation() {
        
    }
    
    public Reservation(int customerNumber,LocalDate day,int startHour,int endHour,int groupSize,String room) {
        this.customerNumber = customerNumber;
        this.day = day;
        this.startHour = startHour;
        this.endHour = endHour;
        this.groupSize = groupSize;
        this.room = room;
    }
    
    public int getIdNumber() { return idNumber; }
    public void setIdNumber(int n) { idNumber = n; }
    public int getCustomerNumber() { return customerNumber; }
    public void setCustomerNumber(int n) { customerNumber = n; }
    public LocalDate getDate() { return day; }
    public void setDate(LocalDate d) { day = d; }
    public int getStart() { return startHour; }
    public void setStart(int hr) { startHour = hr; }
    public int getEnd() { return endHour; }
    public void setEnd(int hr) { endHour = hr; }
    public int getGroupSize() { return groupSize; }
    public void setGroupSize(int size) { groupSize = size; }
    public String getRoom() { return room; }
    
    public String toString() {
        return idNumber + "(" + groupSize + "):" + startHour + "-" + endHour;
    }
    
    @Override
    public int compareTo(Reservation o) {
        if(day.isBefore(o.day))
            return -1;
        if(day.isAfter(o.day))
            return 1;
        if(endHour <= o.startHour)
            return -1;
        else if(startHour >= o.endHour)
            return 1;
        return 0;
    }   
}
