package edu.lawrence.hotelsql;

import edu.lawrence.hotel.HotelDAO;
import java.net.URL;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextField;
import edu.lawrence.hotel.Reservation;
import javafx.scene.control.Label;

/**
 * FXML Controller class
 *
 * @author Joe Gregg
 */
public class FXMLNewReservationDialogController implements Initializable {
    private HotelDAO dao;
    
    @FXML
    private TextField customerNumber;
    @FXML
    private TextField groupSize;
    @FXML
    private TextField startTime;
    @FXML
    private TextField endTime;
    @FXML
    private void cancelDialog(ActionEvent event) {
        customerNumber.getScene().getWindow().hide();
    }
    @FXML
    private Label errorText;
    
    @FXML
    private void acceptDialog(ActionEvent event) {
        int custNumber = Integer.parseInt(customerNumber.getText());
        int start = Integer.parseInt(startTime.getText());
        int end = Integer.parseInt(endTime.getText());
        int size = Integer.parseInt(groupSize.getText());
        Reservation newReservation = new Reservation(custNumber,dao.getDate(),start,end,size,dao.getRoom());
        if(dao.allowsReservation(newReservation)) {
            dao.addReservation(newReservation);
            customerNumber.getScene().getWindow().hide();
        } else
            errorText.setText("The reservation can not be scheduled.");
    }
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
    }    
    
    public void setDAO(HotelDAO dao) {
        this.dao = dao;
    }
}
